IndexOptions (Lucene 10.5.1 core API)
Description: declaration: package: org.apache.lucene.index, enum: IndexOptions

Package org.apache.lucene.index

# Enum Class IndexOptions

java.lang.Object
java.lang.Enum<IndexOptions>
org.apache.lucene.index.IndexOptions

All Implemented Interfaces:
  `Serializable`, `Comparable<IndexOptions>`, `Constable`

public enum IndexOptions extends Enum<IndexOptions>
Controls how much information is stored in the postings lists.

WARNING: This API is experimental and might change in incompatible ways in the next release.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `DOCS`
  Only documents are indexed: term frequencies and positions are omitted.
  `DOCS_AND_CUSTOM_FREQS`
  Like DOCS_AND_FREQS except the "custom freqs" are treated as scores and do not represent term counts.
  `DOCS_AND_FREQS`
  Only documents and term frequencies are indexed: positions are omitted.
  `DOCS_AND_FREQS_AND_POSITIONS`
  Indexes documents, frequencies and positions.
  `DOCS_AND_FREQS_AND_POSITIONS_AND_OFFSETS`
  Indexes documents, frequencies, positions and offsets.
  `NONE`
  Not indexed

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `subsumes(IndexOptions other)`
  Return true if the index format encoding this IndexOptions includes the bits required for the other index format.
  `static IndexOptions`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static IndexOptions[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### NONE

    public static final IndexOptions NONE
    Not indexed

  - ### DOCS

    public static final IndexOptions DOCS
    Only documents are indexed: term frequencies and positions are omitted. Phrase and other positional queries on the field will throw an exception, and scoring will behave as if any term in the document appears only once.

  - ### DOCS_AND_FREQS

    public static final IndexOptions DOCS_AND_FREQS
    Only documents and term frequencies are indexed: positions are omitted. This enables normal scoring, except Phrase and other positional queries will throw an exception.

  - ### DOCS_AND_FREQS_AND_POSITIONS

    public static final IndexOptions DOCS_AND_FREQS_AND_POSITIONS
    Indexes documents, frequencies and positions. This is a typical default for full-text search: full scoring is enabled and positional queries are supported.

  - ### DOCS_AND_FREQS_AND_POSITIONS_AND_OFFSETS

    public static final IndexOptions DOCS_AND_FREQS_AND_POSITIONS_AND_OFFSETS
    Indexes documents, frequencies, positions and offsets. Character offsets are encoded alongside the positions.

  - ### DOCS_AND_CUSTOM_FREQS

    public static final IndexOptions DOCS_AND_CUSTOM_FREQS
    Like DOCS_AND_FREQS except the "custom freqs" are treated as scores and do not represent term counts. Each term can only occur once per document, so its frequency in that sense is always 1.

- ## Method Details

  - ### values

    public static IndexOptions[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static IndexOptions valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### subsumes

    public boolean subsumes(IndexOptions other)
    Return true if the index format encoding this IndexOptions includes the bits required for the other index format. This function provides a partial ordering of the options. The options can't be totally ordered because DOCS_AND_FREQS and DOCS_AND_CUSTOM_FREQS, which are encoded using the same bits, are treated as distinct options due to their different interpretations.